<?php
defined('C5_EXECUTE') or die('Access Denied.');

use Concrete\Core\User\User;
use Concrete\Core\Page\Page;
use Concrete\Core\View\View;

/*
 * John Liddiard (aka JohntheFish) www.c5magic.co.uk
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

/*
 * A single result is effectively a list of 1 specific item, so
 * a trivial case of the corresponding list_results template
 */

$rows_output = 0;
if (!empty($result)) {
    $form_data = $result['form_data'] ?? null;
    if (!empty($show_data) || !empty($all_data)) {
        /*
         * We use some common elements to implement the display of each item. For custom templates,
         * you may want to either create your own elements or to code the display of a result inline
         */
        View::element('view/result_as_content',
                      [
                          'controller' => $controller,
                          'form_data'  => $form_data,
                          'result'     => $result,
                      ],
                      'jl_form_reform_display');

        $rows_output = 1;
    }
}


/*
 * All testing needed to display a no result message or an edit mode
 * marker is provided in the element. Just tack this on the end.
 * The controlling flag is $rows_output.
 */
View::element('view/no_result_check',
              [
                  'controller'        => $controller,
                  'rows_output'       => $rows_output,
                  'no_result_message' => $no_result_message,
              ],
              'jl_form_reform_display');
