<?php

namespace Concrete\Package\JlFormReformDisplay\Block\JlFormReformDisplayResult;

defined('C5_EXECUTE') or die('Access Denied.');

use JtF\FormReformDisplay\DisplayBlockController;
use JtF\FormReformDisplay\Reports\ListMakerDefault;

/*
 * John Liddiard (aka JohntheFish) www.c5magic.co.uk
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

class Controller extends DisplayBlockController
{

    protected $btTable = 'btJlFormReformDisplayResult';


    public function getBlockTypeName()
    {
        return t('Display Result');
    }

    public function getBlockTypeDescription()
    {
        return t('Display a single form result from the Form Reform default store.');
    }


    public function on_before_render()
    {
        parent::on_before_render();
        $this->set('metadata_columns', ListMakerDefault::metadata_columns()); // not user specific

        if (!empty($this->form_name)) {
            if(!empty($this->json_filter_configuration)){
                $this->filter_configuration['json_filter'] = $this->json_filter_configuration;
            }
            $lister = $this->app->make(ListMakerDefault::class, [
                'form_name'            => $this->getFormNameToList(),
                'filter_configuration' => $this->filter_configuration ?? null,
                'number_results'       => 1,
                'order_by'             => $this->order_by ?? null,
                'paginate'             => false,
            ]);

            /*
             * We implement an offset by having a page size of 1 (above) and then setting a page number.
             * Page numbers start at 1, so we also add 1 to the offset to make it consistent with the
             * way the paginator works.
             */
            if (!empty($this->offset)) {
                $lister->set_pagination_page($this->offset + 1);
            }

            $results = $lister->get_paginated_listing();
            if (!empty($results)) {
                $result = reset($results);
            } else {
                $result = null;
            }
            $this->set('result', $result);
        }
    }

}
