<?php
defined('C5_EXECUTE') or die('Access Denied.');

use Concrete\Core\User\User;
use Illuminate\Support\Arr;


/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */


extract($controller->getSets());
if (empty($info_message)) {
    $info_message = t('Select the data to display.');
}

?>
<fieldset style="margin-top:20px;">
    <div class="alert alert-info">
        <?php
        echo $info_message;
        ?>
    </div>

    <div id="data_config_container" class="form-group">
        <table class="table table-bordered table-striped table-condensed">
            <thead>
            <tr>
                <th colspan="2">
                    <?php
                    echo t('Metadata or input_name');
                    ?>
                </th>
                <th>
                    <?php
                    echo t('Label to display');
                    ?>
                </th>
                <th>
                    <?php
                    echo t('Format');
                    ?>
                </th>
                <th>
                    <a href="#add_data_item" class="add_data_item btn btn-success btn-sm"
                       title="<?php echo t('Add'); ?>">
                        <i class="fa fas fa-plus"></i>
                    </a>
                </th>
            </tr>
            </thead>
            <tbody>
            <?php

            $form_input_name_rows = 0;
            if (!empty($show_data)) {
                foreach ($show_data as $k => $v) {
                    if (!empty($metadata_columns) && !array_key_exists($k, $metadata_columns)) {
                        $form_input_name_rows++;
                        break;
                    }
                }
            }

            if (empty($form_input_name_rows)) {
                $show_data['__proforma__jtf__'] = '';
                $show_data_label['__proforma__jtf__'] = '';
            }

            if (!empty($show_data)) {
                foreach ($show_data as $k => $v) {

                    if (!empty($metadata_columns) && array_key_exists($k, $metadata_columns)) {
                        $row_type = 'metadata_row';
                    } else {
                        $row_type = 'form_input_name_row';
                    }

                    ?>
                    <tr class="<?php echo $row_type; ?>" <?php
                    if ((empty($k) || $k === '__proforma__jtf__') && empty($v) && empty($show_data_label[$k])) {
                        echo ' style="display:none"';
                    } ?>>
                        <?php
                        /*
                         * Entry is different depending on whether we have metadata
                         * or if it is form data
                         */
                        if ($row_type === 'metadata_row') {
                            ?>
                            <td>
                                <?php
                                echo $form->checkbox('show_data[' . $k . ']', 1, !empty($show_data[$k]));
                                ?>
                            </td>
                            <td>
                                <?php
                                echo $metadata_columns[$k] ?? null;
                                ?>
                            </td>

                            <?php
                        } else {
                            ?>
                            <td colspan="2" class="show_data_form_input_name">
                                <?php
                                echo $form->handle_dot('show_data[' . $k . ']',
                                                 $show_data[$k] ?? null,
                                                 [
                                                     'maxlength'   => 255,
                                                     'placeholder' => t('input_name'),
                                                 ]
                                );
                                ?>
                            </td>
                            <?php
                        }

                        /*
                         * Columns for both kinds of row
                         */
                        ?>
                        <td class="show_data_label">
                            <?php
                            if (empty($show_data_label[$k])) {
                                $show_data_label[$k] = '';
                            }
                            echo $form->text('show_data_label[' . $k . ']',
                                             $show_data_label[$k] ?? null,
                                             [
                                                 'maxlength'   => 255,
                                                 'placeholder' => t('optional label to display on page'),
                                             ]
                            );
                            ?>
                        </td>
                        <td class="show_data_format">
                            <?php
                            if ($row_type !== 'metadata_row') {
                                if (empty($show_html[$k])) {
                                    $format_hint = '';
                                } elseif ($show_html[$k] === 1 || $show_html[$k] === '1' || $show_html[$k] === true) {
                                    $format_hint = 'html';
                                } else {
                                    $format_hint = $show_html[$k];
                                }
                                echo $form->select('show_html[' . $k . ']',
                                                   $controller->dataFormatOptions(),
                                                   $format_hint
                                );
                            }
                            ?>
                        </td>
                        <td>
                            <a href="#sort_data_item" class="sort_data_item btn btn-secondary btn-sm"
                               title="<?php echo t('Drag to sort'); ?>"
                               style="cursor: move;cursor: grab;cursor: -moz-grab;cursor: -webkit-grab;"
                            >
                                <i class="fa fas fa-arrows-v fa-arrows-alt-v"></i>
                            </a>
                            <?php
                            if ($row_type === 'form_input_name_row') {
                                ?>
                                <a href="#remove_data_item" class="remove_data_item btn btn-danger btn-sm"
                                   title="<?php echo t('Remove'); ?>">
                                    <i class="fa fas fa-trash"></i>
                                </a>
                                <?php
                            }
                            ?>
                        </td>
                    </tr>
                    <?php
                }
            }

            /*
             * Any metadata not already shown, provide options for it
             */
            if (!empty($metadata_columns)) {
                foreach ($metadata_columns as $k => $v) {
                    if (!empty($show_data) && array_key_exists($k, $show_data)) {
                        continue;
                    }
                    ?>
                    <tr class="metadata_row">
                        <td>
                            <?php
                            echo $form->checkbox('show_data[' . $k . ']', 1, !empty($show_data[$k]));
                            ?>
                        </td>
                        <td>
                            <?php
                            echo $v;
                            ?>
                        </td>
                        <td>
                            <?php
                            echo $form->text('show_data_label[' . $k . ']',
                                             '',
                                             [
                                                 'maxlength'   => 255,
                                                 'placeholder' => t('optional label to display on page'),
                                             ]
                            );
                            ?>
                        </td>
                        <td>
                        </td>
                        <td>
                            <a href="#sort_data_item" class="sort_data_item btn btn-secondary btn-sm"
                               title="<?php echo t('Drag to sort'); ?>"
                               style="cursor: move;cursor: grab;cursor: -moz-grab;cursor: -webkit-grab;"
                            >
                                <i class="fa fas fa-arrows-v fa-arrows-alt-v"></i>
                            </a>
                        </td>

                    </tr>
                    <?php
                }
            }
            ?>
            </tbody>
        </table>
    </div>
    <script type="text/javascript">
        (function ($) {
            $(document).ready(function () {
                var data_config_container = $('#data_config_container');

                /*
                 * always have at least one empty row
                 */
                data_config_container.on('click', '.remove_data_item', function (ev) {
                    ev.preventDefault();
                    ev.stopPropagation();
                    var this_row = $(this).closest('.form_input_name_row');
                    if (data_config_container.find('.form_input_name_row').length < 2) {
                        var text_inputs = this_row.find('input[type="text"]');
                        text_inputs.val('').removeAttr('id').removeAttr('value');
                        data_config_container.find('tr').last().after(this_row);
                        text_inputs.each(function () {
                            var this_text_input = $(this);
                            var input_name = this_text_input.attr('name');
                            var new_empty_input_name = input_name.replace(/\[.*?\]/, '[]');
                            this_text_input.attr('name', new_empty_input_name);
                        });
                        this_row.hide();
                        return;
                    }
                    this_row.remove();
                });

                /*
                 * Add a new form input_name. Either copy an existing input, or use a hidden blank input.
                 */
                data_config_container.on('click', '.add_data_item', function (ev) {
                    ev.preventDefault();
                    ev.stopPropagation();
                    var row_to_copy = data_config_container.find('.form_input_name_row').last();
                    if (row_to_copy.is(':visible')) {
                        var new_row = row_to_copy.clone();
                        new_row.find('input').val('');
                        row_to_copy.after(new_row);
                        new_row.find('.show_data_form_input_name input').trigger('keyup');
                    } else {
                        row_to_copy.show();
                        row_to_copy.trigger('keyup');
                    }
                });

                /*
                 * IMPORTANT - does not work like our other expanding tables of inputs
                 *  labels and formats are keyed on the value of the label.
                 *  (Should have done this the usual way, but its too late now. Sites with legacy use!)
                 */
                data_config_container.on('keyup', '.show_data_form_input_name input', function () {
                    var this_input = $(this);
                    this_input.removeAttr('id');
                    var corresponding_label_input = this_input.closest('.form_input_name_row').find('.show_data_label input');
                    corresponding_label_input.removeAttr('id');

                    var corresponding_format_input = this_input.closest('.form_input_name_row').find('.show_data_format select');
                    corresponding_format_input.removeAttr('id');

                    var input_handle = make_handle(this_input.val());
                    this_input.val(input_handle);
                    /*
                     * Modify the [key] part of array input names to match the form
                     * item handle
                     */
                    var this_input_name = this_input.attr('name');
                    var new_input_key = this_input_name.replace(/\[.*?\]/, '[' + input_handle + ']');
                    this_input.attr('name', new_input_key);
                    this_input.attr('value', input_handle);

                    var corresponding_label_input_name = corresponding_label_input.attr('name');
                    var new_label_input_key = corresponding_label_input_name.replace(/\[.*?\]/, '[' + input_handle + ']');
                    corresponding_label_input.attr('name', new_label_input_key);
                    var label_text = corresponding_label_input.val();
                    corresponding_label_input.attr('value', label_text);

                    var corresponding_format_input_name = corresponding_format_input.attr('name');
                    var new_format_input_key = corresponding_format_input_name.replace(/\[.*?\]/, '[' + input_handle + ']');
                    corresponding_format_input.attr('name', new_format_input_key);
                    var format_text = corresponding_format_input.val();
                    corresponding_format_input.attr('value', format_text);

                    return true;
                });

                /*
                 * Note, additional characters to manage array selectors
                 * These get split out into a series of keys into the array
                 * when the data is extracted (php)
                 */
                var make_handle = function (k) {
                    if (!k || k.length < 1) {
                        return '';
                    }
                    return k.toLowerCase().replace(/[^a-z0-9_\.\[\]]/, '');
                };

                data_config_container.sortable({
                    axis: 'y',
                    classes: {
                        'form_input_name_row': 'selected',
                        'metadata_row': 'selected'
                    },
                    containment: 'parent',
                    cursor: 'grabbing',
                    handle: '.sort_data_item',
                    items: '.form_input_name_row,.metadata_row',
                    scroll: true,
                    helper: function (ev, ui) {
                        ui.width(ui.width());
                        ui.find('td').each(function () {
                            $(this).width($(this).width());
                        })
                        return ui;
                    },
                    stop: function (ev, ui) {
                        data_config_container.find('.form_input_name_row,.metadata_row').removeAttr('style');
                        return ui;
                    }
                });

            });
        })(jQuery);
    </script>

    <div class="alert alert-info">
        <dl>
            <dt>
                <?php
                echo t('Metadata');
                ?>
            </dt>
            <dd>
                <?php
                echo t('Data recorded for all submissions, tick the checkbox to enable.');
                ?>
            </dd>
            <?php
            $u = new User();
            if (is_object($u) && $u->isSuperUser()) {
                ?>
                <dt class="text-danger">
                    <?php
                    echo t('Session ID');
                    ?>
                </dt>
                <dd  class="text-danger">
                    <?php
                    echo t('An option to display the session ID can only be configured by the super user. Use this only for diagnostic purposes. Showing a session ID on a live site is a security risk.');
                    ?>
                </dd>
                <?php
            }
            ?>
            <dt>
                <?php
                echo t('input_name');
                ?>
            </dt>
            <dd>
                <?php
                echo t('A form input, enter a handle such as first_name.');
                ?>
            </dd>
            <dt>
                <?php
                echo t('Label to display');
                ?>
            </dt>
            <dd>
                <?php
                echo t('The label to be used when displaying the data, optional.');
                ?>
            </dd>
        </dl>
    </div>

    <div class="alert alert-warning">

        <div class="form_group">
            <div class="form-check">
                <?php
                if (empty($all_data)) {
                    $all_data = false;
                }
                echo $form->checkbox('all_data', 1, $all_data);
                echo $form->label('all_data', t('Append all form data not explicitly configured above'));
                ?>
            </div>
        </div>

        <?php
        echo t('Appending remaining data may result in data being dumped in JSON format into the display. You should know the data recorded from your form and select columns accordingly. This option is provided primarily as a diagnostic.')
        ?>
    </div>


</fieldset>
