<?php
defined('C5_EXECUTE') or die('Access Denied.');

use JtF\FormReformDisplay\Reports\ListMakerDefault;
use JtFResources\Utilities\FormNoId;

/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */


/*
 * For compatibility between UCP plugin and
 * block dialogue
 */
extract($controller->getSets());
$form = $app->make(FormNoId::class);

if (!empty($data) && is_callable([$plugin, 'synthesizeData'])) {
    $data = $plugin->synthesizeData($data);
}

/*
 * Filter list by date
 */
?>
    <div id="date_filter">
        <div id="date_filter_mode_select" class="form-group">
            <?php

            if (empty($data['date_filter_mode'])) {
                $data['date_filter_mode'] = ListMakerDefault::filter_date_default();
            }
            echo $form->label($plugin->prefixNamespace('date_filter_mode'), t('Filter by date submitted'));
            echo $form->select($plugin->prefixNamespace('date_filter_mode'),
                               ListMakerDefault::filter_date_options(),
                               $data['date_filter_mode']
            );
            ?>
        </div>
        <div id="date_filter_days" class="form-group">
            <div class="input-group">
                <div class="input-group-addon input-group-text" style="min-width:150px">
                    <?php
                    echo t('Before today');
                    ?>
                </div>
                <?php
                if (empty($data['number_days'])) {
                    $data['number_days'] = 0;
                }
                echo $form->number($plugin->prefixNamespace('number_days'), $data['number_days'], ['min' => 0]);
                ?>
                <div class="input-group-addon input-group-text">
                    <?php
                    echo t('Days');
                    ?>
                </div>
            </div>
        </div>
        <div id="date1" class="form-group">
            <div class="input-group">
                <div class="input-group-addon input-group-text" style="min-width:150px">
                <span id="date1_on">
                    <?php
                    echo t('On date');
                    ?>
                </span>
                    <span id="date1_from">
                    <?php
                    echo t('From date');
                    ?>
                </span>
                </div>
                <?php
                if (empty($data['date1'])) {
                    $data['date1'] = null;
                }
                echo $form->date($plugin->prefixNamespace('date1'), $data['date1']);
                ?>
            </div>
        </div>
        <div id="date2" class="form-group">
            <div class="input-group">
                <div class="input-group-addon input-group-text" style="min-width:150px">
                    <?php
                    echo t('To date');
                    ?>
                </div>
                <?php
                if (empty($data['date2'])) {
                    $data['date2'] = null;
                }
                echo $form->date($plugin->prefixNamespace('date2'), $data['date2']);
                ?>
            </div>
        </div>
        <script type="text/javascript">
            (function ($) {
                $(document).ready(function () {
                    var date_filter_mode_select = $('#date_filter_mode_select select');
                    var date_filter_days = $('#date_filter_days');
                    var date1 = $('#date1');
                    var date2 = $('#date2');
                    var date1_on = $('#date1_on');
                    var date1_from = $('#date1_from');

                    date_filter_mode_select.on('change', function () {
                        switch ($(this).val()) {
                            case 'past':
                                date_filter_days.show();
                                date1.hide();
                                date2.hide();
                                break;
                            case 'on':
                                date_filter_days.hide();
                                date1.show();
                                date1_on.show();
                                date1_from.hide();
                                date2.hide();
                                break;
                            case 'between':
                                date_filter_days.hide();
                                date1.show();
                                date1_on.hide();
                                date1_from.show();
                                date2.show();
                                break;
                            default:
                            case 'all':
                            case 'now':
                                date_filter_days.hide();
                                date1.hide();
                                date2.hide();
                                break;
                        }
                    }).trigger('change');
                });
            })(jQuery);
        </script>
        <?php

        ?>
    </div>

<?php

if (empty($data_store_is_user_specific)) {
    /*
     * Filter list by user submitting form
     */
    ?>
    <div id="user_filter">
        <div id="user_filter_mode_select" class="form-group">
            <?php

            if (empty($data['user_filter_mode'])) {
                $data['user_filter_mode'] = ListMakerDefault::filter_user_default();
            }
            echo $form->label($plugin->prefixNamespace('user_filter_mode'), t('Filter by user'));
            echo $form->select($plugin->prefixNamespace('user_filter_mode'),
                               ListMakerDefault::filter_user_options(),
                               $data['user_filter_mode']
            );
            ?>
        </div>
        <div id="user_select" class="form-group">
            <div class="input-group">
                <?php
                if (empty($data['uid'])) {
                    $data['uid'] = 0;
                }
                $user_form = $app->make('helper/form/user_selector');
                echo $user_form->selectUser($plugin->prefixNamespace('uid'), $data['uid']);
                ?>
            </div>
        </div>
        <script type="text/javascript">
            (function ($) {
                $(document).ready(function () {
                    var user_filter_mode_select = $('#user_filter_mode_select select');
                    var user_select = $('#user_select');

                    user_filter_mode_select.on('change', function () {
                        switch ($(this).val()) {
                            case 'selected':
                                user_select.show();
                                break;
                            case 'none':
                            case 'not_registered':
                            case 'registered':
                            case 'current':
                            default:
                                user_select.hide();
                                break;

                        }
                    }).trigger('change');
                });
            })(jQuery);
        </script>
        <?php

        ?>
    </div>
    <?php
}
?>
<?php
/*
 * Filter list by page submitting form
 */
?>
    <div id="page_filter">
        <div id="page_filter_mode_select" class="form-group">
            <?php

            if (empty($data['page_filter_mode'])) {
                $data['page_filter_mode'] = ListMakerDefault::filter_page_default();
            }
            echo $form->label($plugin->prefixNamespace('page_filter_mode'), t('Filter by page'));
            echo $form->select($plugin->prefixNamespace('page_filter_mode'),
                               ListMakerDefault::filter_page_options(),
                               $data['page_filter_mode']
            );
            ?>
        </div>
        <div id="page_select" class="form-group">
            <div class="input-group">
                <?php
                if (empty($data['cid'])) {
                    $data['cid'] = 0;
                }
                $page_form = $app->make('helper/form/page_selector');
                echo $page_form->selectPage($plugin->prefixNamespace('cid'), $data['cid']);
                ?>
            </div>
        </div>
        <script type="text/javascript">
            (function ($) {
                $(document).ready(function () {
                    var page_filter_mode = $('#page_filter_mode_select');
                    var page_filter_mode_select = page_filter_mode.find('select').first();
                    var page_select = $('#page_select');
                    var option_none = page_filter_mode_select.find('option[value="none"]');

                    page_filter_mode_select.on('change', function () {
                        switch ($(this).val()) {
                            case 'selected':
                            case 'beneath_selected':
                                page_select.show();
                                break;
                            case 'none':
                            case 'current':
                            case 'beneath_current':
                            default:
                                page_select.hide();
                                break;
                        }
                    }).trigger('change');

                    /*
                     * Don't show a none option for the page attribute display
                     */
                    var store_select = $('#store_select select');
                    store_select.on('change', function () {
                        if ($(this).val() === 'page_attr') {
                            option_none.hide();
                            var sel_val = page_filter_mode_select.val();
                            if (!sel_val || sel_val.length < 1 || sel_val === 'none') {
                                page_filter_mode_select.val('selected');
                            }
                        } else {
                            option_none.show();
                        }
                    }).trigger('change');
                });
            })(jQuery);
        </script>
    </div>
<?php
/*
 * TODO - MAYBE DO SIMILAR FOR USER
 */