<?php
defined('C5_EXECUTE') or die('Access Denied.');
/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */

/*
 * For compatibility between block dialogues
 */
extract($controller->getSets());

?>
<fieldset style="margin-top:20px;">
    <div class="form-group">
        <?php
        if (empty($number_results)) {
            $number_results = 0;
        }
        if(empty($number_of_results_message)){
            $number_of_results_message = t('Number of results to show');
        }
        echo $form->label('number_results', $number_of_results_message);
        echo $form->number('number_results', $number_results, ['min' => 0, 'max' => 1000]);
        ?>
        <div class="alert alert-info">
            <?php
            echo t('Leave empty/zero for no limit')
            ?>
        </div>
    </div>

    <?php
    if (empty($pagination_not_supported)) {
        ?>
        <div class="form_group">
            <div class="form-check">
                <?php
                if (empty($paginate)) {
                    $paginate = false;
                }
                echo $form->checkbox('paginate', 1, $paginate);
                echo $form->label('paginate', t('Paginate if more results'));
                ?>
            </div>
        </div>
        <?php
    }
    ?>

    <div class="form-group">
        <?php
        $order_by_options = [
            'desc_id' => t('Most recent first'),
            'asc_id'  => t('Oldest first'),
        ];

        if (empty($order_by)) {
            $order_by = 'desc_id';
        }
        echo $form->label('order_by', t('Sort by'));
        echo $form->select('order_by', $order_by_options, $order_by);
        ?>
    </div>

    <div class="form-group">
        <?php
        if (empty($no_result_message)) {
            $no_result_message = '';
        }
        echo $form->label('no_result_message', t('Message to show when no results'));
        echo $form->text('no_result_message', $no_result_message, ['minlenth' => 0, 'maxlength' => 255]);
        ?>
    </div>
</fieldset>