<?php

use JtF\FormReformDisplay\DisplayItemFormatter;

defined('C5_EXECUTE') or die('Access Denied.');

/*
 * Software by John Liddiard (aka JohntheFish)
 * www.c5magic.co.uk
 *
 * This package contains software copyright and proprietary to John Liddiard
 *
 */
extract($controller->getSets());


if (empty($item_class)) {
    $item_class = 'form-data-result-item';
}
if (empty($label_class)) {
    $label_class = 'form-data-result-item-label';
}
if (empty($item_content_class)) {
    $item_content_class = 'form-data-result-item-value';
}
if (empty($result_class)) {
    $result_class = 'form-reform-display-list-results-as-dl';
}

if (!empty($v8)) {
    $dl_class = 'dl-horizontal';
    $dt_class = '';
    $dd_class = '';
} else {
    $dl_class = 'dl-horizontal row';
    $dt_class = 'col-sm-3 text-end';
    $dd_class = 'col-sm-9';
}

if (empty($date_format)) {
    $date_format = 'Y-m-d H:i:s';
}

?>
<div class="form-reform-display-list-results-result border-primary bg-light mb-3 p-3 well"<?php echo $controller->id_attr($result_id ?? null); ?>>
    <dl class="<?php echo $dl_class; ?>">
        <?php
        if (!empty($show_data)) {
            /*
             * Go through the columns configured in the 'Data' tab
             * in the sorted order
             */

            foreach ($show_data as $k => $v) {
                unset($data_item);
                if ($k === '__proforma__jtf__') {
                    continue;
                }
                if (!empty($show_data_label[$k])) {
                    $data_label = $show_data_label[$k];
                } else {
                    $data_label = '';
                }

                $display_formatter = new DisplayItemFormatter($k, $result, $form_data, $date_format);

                if (array_key_exists($k, $metadata_columns)) {
                    $row_type = 'form-metadata-item';
                    $data_item = $display_formatter->formatMetadataItem();

                } else {
                    /*
                     * A form data item
                     */
                    $row_type = 'form-field-value-item';
                    $format_hint = (string)($show_html[$k] ?? false);
                    $data_item = $display_formatter->formatDataItem($format_hint, $format_helpers ?? null);
                }

                if (!empty($data_item)) {
                    ?>
                    <dt class="<?php echo $result_class . ' ' . $dt_class . ' ' . $label_class . ' ' . $row_type . ' ' . $item_class . ' ' . $item_class . '-' . $k; ?>">
                        <?php
                        echo h($data_label);
                        ?>
                    </dt>
                    <dd class="<?php echo $result_class . ' ' . $dd_class . ' ' . $item_content_class . ' ' . $row_type . ' ' . $item_class . ' ' . $item_class . '-' . $k; ?>">
                        <?php
                        echo $data_item;
                        ?>
                    </dd>
                    <?php
                }
            }
        }

        /*
         * May also be configured to show any leftovers
         */
        if (!empty($all_data) && !empty($form_data)) {
            foreach ($form_data as $k => $v) {
                if (!empty($show_data) && array_key_exists($k, $show_data)) {
                    continue;
                }
                $row_type = 'form-field-value-item form-remaining-data';
                if (is_scalar($form_data[$k])) {
                    $data_item = $form_data[$k];
                } else {
                    /*
                     * Use json here so admin gets enough info to code specifically for
                     * it later.
                     */
                    $data_item = json_encode(($form_data[$k]), JSON_PRETTY_PRINT);
                }
                $data_label = $k;
                ?>
                <dt class="<?php echo $result_class . ' ' . $dt_class . ' ' . $label_class . ' ' . $row_type . ' ' . $item_class; ?>">
                    <?php
                    echo h($data_label);
                    ?>
                </dt>
                <dd class="<?php echo $result_class . ' ' . $dd_class . ' ' . $item_content_class . ' ' . $row_type . ' ' . $item_class; ?>">
                    <?php
                    if (is_scalar($data_item)) {
                        echo $data_item;
                    } else {
                        echo h(json_encode($data_item, JSON_UNESCAPED_SLASHES + JSON_UNESCAPED_UNICODE));
                    }
                    ?>
                </dd>
                <?php
            }
        }
        ?>
    </dl>
</div>